Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34921)
@@ -1545,12 +2119,37 @@
     my ($numNew, $numPseudo) = $self->CountNewValues();
     if (not defined $outfile and defined $infile) {
-        my $newFileName =  $self->GetNewValues('FileName', \$nvHash);
+        $hardLink = $self->GetNewValue('HardLink');
+        $symLink = $self->GetNewValue('SymLink');
+        $testName = $self->GetNewValue('TestName');
+        undef $hardLink if defined $hardLink and not length $hardLink;
+        undef $symLink if defined $symLink and not length $symLink;
+        undef $testName if defined $testName and not length $testName;
+        my $newFileName =  $self->GetNewValue('FileName', \$nvHash);
+        my $newDir = $self->GetNewValue('Directory');
+        if (defined $newDir and length $newDir) {
+            $newDir .= '/' unless $newDir =~ m{/$};
+        } else {
+            undef $newDir;
+        }
         if ($numNew == $numPseudo) {
             $rtnVal = 2;
-            if (defined $fileModifyDate and (not ref $infile or UNIVERSAL::isa($infile,'GLOB'))) {
-                $self->SetFileModifyDate($infile) > 0 and $rtnVal = 1;
-            }
-            if (defined $newFileName and not ref $infile) {
-                $self->SetFileName($infile) > 0 and $rtnVal = 1;
+            if ((defined $newFileName or defined $newDir) and not ref $infile) {
+                my $result = $self->SetFileName($infile);
+                if ($result > 0) {
+                    $infile = $$self{NewName};  # file name changed
+                    $rtnVal = 1;
+                } elsif ($result < 0) {
+                    return 0;   # don't try to do anything else
+                }
+            }
+            if (not ref $infile or UNIVERSAL::isa($infile,'GLOB')) {
+                $self->SetFileModifyDate($infile) > 0 and $rtnVal = 1 if $setModDate;
+                $self->SetFileModifyDate($infile, undef, 'FileCreateDate') > 0 and $rtnVal = 1 if $setCreateDate;
+                $self->SetSystemTags($infile) > 0 and $rtnVal = 1;
+            }
+            if (defined $hardLink or defined $symLink or defined $testName) {
+                $hardLink and $self->SetFileName($infile, $hardLink, 'HardLink') and $rtnVal = 1;
+                $symLink and $self->SetFileName($infile, $symLink, 'SymLink') and $rtnVal = 1;
+                $testName and $self->SetFileName($infile, $testName, 'Test') and $rtnVal = 1;
             }
             return $rtnVal;
@@ -1561,7 +2160,15 @@
                 $outfile = $newFileName;
                 # can't delete original
-            } elsif (IsOverwriting($nvHash, $infile)) {
+            } elsif ($self->IsOverwriting($nvHash, $infile)) {
                 $outfile = GetNewFileName($infile, $newFileName);
                 $eraseIn = 1; # delete original
+            }
+        }
+        # set new directory if specified
+        if (defined $newDir) {
+            $outfile = $infile unless defined $outfile or ref $infile;
+            if (defined $outfile) {
+                $outfile = GetNewFileName($outfile, $newDir);
+                $eraseIn = 1 unless ref $infile;
             }
         }
@@ -1574,7 +2181,10 @@
         if (UNIVERSAL::isa($inRef,'GLOB')) {
             seek($inRef, 0, 0); # make sure we are at the start of the file
-        } elsif ($] >= 5.006 and (eval 'require Encode; Encode::is_utf8($$inRef)' or $@)) {
+        } elsif (UNIVERSAL::isa($inRef,'File::RandomAccess')) {
+            $inRef->Seek(0);
+            $raf = $inRef;
+        } elsif ($] >= 5.006 and (eval { require Encode; Encode::is_utf8($$inRef) } or $@)) {
             # convert image data from UTF-8 to character stream if necessary
-            my $buff = $@ ? pack('C*',unpack('U0C*',$$inRef)) : Encode::encode('utf8',$$inRef);
+            my $buff = $@ ? pack('C*',unpack($] < 5.010000 ? 'U0C*' : 'C0C*',$$inRef)) : Encode::encode('utf8',$$inRef);
             if (defined $outfile) {
                 $inRef = \$buff;
@@ -1586,5 +2196,6 @@
         # write to a temporary file if no output file given
         $outfile = $tmpfile = "${infile}_exiftool_tmp" unless defined $outfile;
-        if (open(EXIFTOOL_FILE2, $infile)) {
+        if ($self->Open(\*EXIFTOOL_FILE2, $infile)) {
+            $fileExt = GetFileExtension($infile);
             $fileType = GetFileType($infile);
             @fileTypeList = GetFileType($infile);
@@ -1604,8 +2215,13 @@
         $outType = GetFileExtension($outfile) unless $outType or ref $outfile;
         if (CanCreate($outType)) {
-            $fileType = $tiffType = $outType;   # use output file type if no input file
-            $infile = "$fileType file";         # make bogus file name
-            $self->VPrint(0, "Creating $infile...\n");
-            $inRef = \ '';      # set $inRef to reference to empty data
+            if ($$self{OPTIONS}{WriteMode} =~ /g/i) {
+                $fileType = $tiffType = $outType;   # use output file type if no input file
+                $infile = "$fileType file";         # make bogus file name
+                $self->VPrint(0, "Creating $infile...\n");
+                $inRef = \ '';      # set $inRef to reference to empty data
+            } else {
+                $self->Error("Not creating new $outType file (disallowed by WriteMode)");
+                return 0;
+            }
         } elsif ($outType) {
             $self->Error("Can't create $outType files");
@@ -1640,10 +2256,14 @@
         # editing in place, so write to memory first
         # (only when infile is a file ref or scalar ref)
+        if ($raf) {
+            $self->Error("Can't edit File::RandomAccess object in place");
+            return 0;
+        }
         $outBuff = '';
         $outRef = \$outBuff;
         $outPos = 0;
-    } elsif (-e $outfile) {
+    } elsif ($self->Exists($outfile)) {
         $self->Error("File already exists: $outfile");
-    } elsif (open(EXIFTOOL_OUTFILE, ">$outfile")) {
+    } elsif ($self->Open(\*EXIFTOOL_OUTFILE, $outfile, '>')) {
         $outRef = \*EXIFTOOL_OUTFILE;
         $closeOut = 1;  # we must close $outRef
@@ -1657,7 +2277,7 @@
 # write the file
 #
-    until ($self->{VALUE}{Error}) {
+    until ($$self{VALUE}{Error}) {
         # create random access file object (disable seek test in case of straight copy)
-        my $raf = new File::RandomAccess($inRef, 1);
+        $raf or $raf = new File::RandomAccess($inRef, 1);
         $raf->BinMode();
         if ($numNew == $numPseudo) {
@@ -1671,5 +2291,5 @@
         } elsif (not ref $infile and ($infile eq '-' or $infile =~ /\|$/)) {
             # patch for Windows command shell pipe
-            $raf->{TESTED} = -1;    # force buffering
+            $$raf{TESTED} = -1; # force buffering
         } else {
             $raf->SeekTest();
@@ -1677,5 +2297,5 @@
        # $raf->Debug() and warn "  RAF debugging enabled!\n";
         my $inPos = $raf->Tell();
-        $self->{RAF} = $raf;
+        $$self{RAF} = $raf;
         my %dirInfo = (
             RAF => $raf,
@@ -1694,8 +2314,8 @@
             }
             # save file type in member variable
-            $dirInfo{Parent} = $self->{FILE_TYPE} = $self->{PATH}[0] = $type;
+            $dirInfo{Parent} = $$self{FILE_TYPE} = $$self{PATH}[0] = $type;
             # determine which directories we must write for this file type
             $self->InitWriteDirs($type);
-            if ($type eq 'JPEG') {
+            if ($type eq 'JPEG' or $type eq 'EXV') {
                 $rtnVal = $self->WriteJPEG(\%dirInfo);
             } elsif ($type eq 'TIFF') {
@@ -1705,57 +2325,26 @@
                     undef $rtnVal;
                 } else {
+                    if ($tiffType eq 'FFF') {
+                        # (see https://exiftool.org/forum/index.php?topic=10848.0)
+                        $self->Error('Phocus may not properly update previews of edited FFF images', 1);
+                    }
                     $dirInfo{Parent} = $tiffType;
                     $rtnVal = $self->ProcessTIFF(\%dirInfo);
                 }
-            } elsif ($type eq 'GIF') {
-                require Image::ExifTool::GIF;
-                $rtnVal = Image::ExifTool::GIF::ProcessGIF($self,\%dirInfo);
-            } elsif ($type eq 'CRW') {
-                require Image::ExifTool::CanonRaw;
-                $rtnVal = Image::ExifTool::CanonRaw::WriteCRW($self, \%dirInfo);
-            } elsif ($type eq 'MRW') {
-                require Image::ExifTool::MinoltaRaw;
-                $rtnVal = Image::ExifTool::MinoltaRaw::ProcessMRW($self, \%dirInfo);
-            } elsif ($type eq 'RAF') {
-                require Image::ExifTool::FujiFilm;
-                $rtnVal = Image::ExifTool::FujiFilm::WriteRAF($self, \%dirInfo);
+            } elsif (exists $writableType{$type}) {
+                my ($module, $func);
+                if (ref $writableType{$type} eq 'ARRAY') {
+                    $module = $writableType{$type}[0] || $type;
+                    $func = $writableType{$type}[1];
+                } else {
+                    $module = $writableType{$type} || $type;
+                }
+                require "Image/ExifTool/$module.pm";
+                $func = "Image::ExifTool::${module}::" . ($func || "Process$type");
+                no strict 'refs';
+                $rtnVal = &$func($self, \%dirInfo);
+                use strict 'refs';
             } elsif ($type eq 'ORF' or $type eq 'RAW') {
                 $rtnVal = $self->ProcessTIFF(\%dirInfo);
-            } elsif ($type eq 'X3F') {
-                require Image::ExifTool::SigmaRaw;
-                $rtnVal = Image::ExifTool::SigmaRaw::ProcessX3F($self, \%dirInfo);
-            } elsif ($type eq 'PNG') {
-                require Image::ExifTool::PNG;
-                $rtnVal = Image::ExifTool::PNG::ProcessPNG($self, \%dirInfo);
-            } elsif ($type eq 'MIE') {
-                require Image::ExifTool::MIE;
-                $rtnVal = Image::ExifTool::MIE::ProcessMIE($self, \%dirInfo);
-            } elsif ($type eq 'XMP') {
-                require Image::ExifTool::XMP;
-                $rtnVal = Image::ExifTool::XMP::WriteXMP($self, \%dirInfo);
-            } elsif ($type eq 'PPM') {
-                require Image::ExifTool::PPM;
-                $rtnVal = Image::ExifTool::PPM::ProcessPPM($self, \%dirInfo);
-            } elsif ($type eq 'PSD') {
-                require Image::ExifTool::Photoshop;
-                $rtnVal = Image::ExifTool::Photoshop::ProcessPSD($self, \%dirInfo);
-            } elsif ($type eq 'EPS' or $type eq 'PS') {
-                require Image::ExifTool::PostScript;
-                $rtnVal = Image::ExifTool::PostScript::WritePS($self, \%dirInfo);
-            } elsif ($type eq 'PDF') {
-                require Image::ExifTool::PDF;
-                $rtnVal = Image::ExifTool::PDF::WritePDF($self, \%dirInfo);
-            } elsif ($type eq 'ICC') {
-                require Image::ExifTool::ICC_Profile;
-                $rtnVal = Image::ExifTool::ICC_Profile::WriteICC($self, \%dirInfo);
-            } elsif ($type eq 'VRD') {
-                require Image::ExifTool::CanonVRD;
-                $rtnVal = Image::ExifTool::CanonVRD::ProcessVRD($self, \%dirInfo);
-            } elsif ($type eq 'JP2') {
-                require Image::ExifTool::Jpeg2000;
-                $rtnVal = Image::ExifTool::Jpeg2000::ProcessJP2($self, \%dirInfo);
-            } elsif ($type eq 'IND') {
-                require Image::ExifTool::InDesign;
-                $rtnVal = Image::ExifTool::InDesign::ProcessIND($self, \%dirInfo);
             } elsif ($type eq 'EXIF') {
                 # go through WriteDirectory so block writes, etc are handled
@@ -1787,5 +2376,5 @@
                 $err = 'Error seeking in file';
             } elsif ($fileType and defined $rtnVal) {
-                if ($self->{VALUE}{Error}) {
+                if ($$self{VALUE}{Error}) {
                     # existing error message will do
                 } elsif ($fileType eq 'RAW') {
@@ -1793,5 +2382,6 @@
                 } else {
                     if ($wrongType) {
-                        $err = "Not a valid $fileType";
+                        my $type = $fileExt || ($fileType eq 'TIFF' ? $tiffType : $fileType);
+                        $err = "Not a valid $type";
                         # do a quick check to see what this file looks like
                         foreach $type (@fileTypes) {
@@ -1820,7 +2410,15 @@
     # don't return success code if any error occurred
     if ($rtnVal > 0) {
-        unless (Tell($outRef) or $self->{VALUE}{Error}) {
+        if ($outType and $type and $outType ne $type) {
+            my @types = GetFileType($outType);
+            unless (grep /^$type$/, @types) {
+                $self->Error("Can't create $outType file from $type");
+                $rtnVal = 0;
+            }
+        }
+        if ($rtnVal > 0 and not Tell($outRef) and not $$self{VALUE}{Error}) {
             # don't write a file with zero length
             if (defined $hdr and length $hdr) {
+                $type = '<unk>' unless defined $type;
                 $self->Error("Can't delete all meta information from $type file");
             } else {
@@ -1828,10 +2426,10 @@
             }
         }
-        $rtnVal = 0 if $self->{VALUE}{Error};
+        $rtnVal = 0 if $$self{VALUE}{Error};
     }
 
     # rewrite original file in place if required
     if (defined $outBuff) {
-        if ($rtnVal <= 0 or not $self->{CHANGED}) {
+        if ($rtnVal <= 0 or not $$self{CHANGED}) {
             # nothing changed, so no need to write $outBuff
         } elsif (UNIVERSAL::isa($inRef,'GLOB')) {
@@ -1844,5 +2442,5 @@
                 print $inRef $outBuff and       # write the new data
                 ($len >= $size or               # if necessary:
-                eval 'truncate($inRef, $len)'); #  shorten output file
+                eval { truncate($inRef, $len) }); #  shorten output file
         } else {
             $$inRef = $outBuff;                 # replace original data
@@ -1856,6 +2454,6 @@
         if ($rtnVal > 0) {
             # copy Mac OS resource fork if it exists
-            if ($^O eq 'darwin' and -s "$infile/rsrc") {
-                if ($$self{DEL_GROUP} and $$self{DEL_GROUP}{RSRC}) {
+            if ($^O eq 'darwin' and -s "$infile/..namedfork/rsrc") {
+                if ($$self{DEL_GROUP}{RSRC}) {
                     $self->VPrint(0,"Deleting Mac OS resource fork\n");
                     ++$$self{CHANGED};
@@ -1864,6 +2462,6 @@
                     my ($buf, $err);
                     local (*SRC, *DST);
-                    if (open SRC, "$infile/rsrc") {
-                        if (open DST, ">$outfile/rsrc") {
+                    if ($self->Open(\*SRC, "$infile/..namedfork/rsrc")) {
+                        if ($self->Open(\*DST, "$outfile/..namedfork/rsrc", '>')) {
                             binmode SRC; # (not necessary for Darwin, but let's be thorough)
                             binmode DST;
@@ -1880,9 +2478,9 @@
                         $err = 'opening';
                     }
-                    $rtnVal = 0 if $err and $self->Error("Error $err Mac OS resource fork", 1);
+                    $rtnVal = 0 if $err and $self->Error("Error $err Mac OS resource fork", 2);
                 }
             }
             # erase input file if renaming while editing information in place
-            unlink $infile or $self->Warn('Error erasing original file') if $eraseIn;
+            $self->Unlink($infile) or $self->Warn('Error erasing original file') if $eraseIn;
         }
     }
@@ -1893,27 +2491,37 @@
         # erase the output file if we weren't successful
         if ($rtnVal <= 0) {
-            unlink $outfile;
+            $self->Unlink($outfile);
         # else rename temporary file if necessary
         } elsif ($tmpfile) {
-            CopyFileAttrs($infile, $tmpfile);   # copy attributes to new file
-            unless (rename($tmpfile, $infile)) {
+            $self->CopyFileAttrs($infile, $tmpfile);    # copy attributes to new file
+            unless ($self->Rename($tmpfile, $infile)) {
                 # some filesystems won't overwrite with 'rename', so try erasing original
-                if (not unlink($infile)) {
-                    unlink $tmpfile;
+                if (not $self->Unlink($infile)) {
+                    $self->Unlink($tmpfile);
                     $self->Error('Error renaming temporary file');
                     $rtnVal = 0;
-                } elsif (not rename($tmpfile, $infile)) {
+                } elsif (not $self->Rename($tmpfile, $infile)) {
                     $self->Error('Error renaming temporary file after deleting original');
                     $rtnVal = 0;
                 }
             }
-        }
-    }
-    # set FileModifyDate if requested (and if possible!)
-    if (defined $fileModifyDate and $rtnVal > 0 and
-        ($closeOut or ($closeIn and defined $outBuff)) and
-        $self->SetFileModifyDate($closeOut ? $outfile : $infile, $originalTime) > 0)
-    {
-        ++$self->{CHANGED}; # we changed something
+            # the output file should now have the name of the original infile
+            $outfile = $infile if $rtnVal > 0;
+        }
+    }
+    # set filesystem attributes if requested (and if possible!)
+    if ($rtnVal > 0 and ($closeOut or (defined $outBuff and ($closeIn or UNIVERSAL::isa($infile,'GLOB'))))) {
+        my $target = $closeOut ? $outfile : $infile;
+        # set file permissions if requested
+        ++$$self{CHANGED} if $self->SetSystemTags($target) > 0;
+        if ($closeIn) { # (no use setting file times unless the input file is closed)
+            ++$$self{CHANGED} if $setModDate and $self->SetFileModifyDate($target, $originalTime, undef, 1) > 0;
+            # set FileCreateDate if requested (and if possible!)
+            ++$$self{CHANGED} if $setCreateDate and $self->SetFileModifyDate($target, $createTime, 'FileCreateDate', 1) > 0;
+            # create hard link if requested and no output filename specified (and if possible!)
+            ++$$self{CHANGED} if defined $hardLink and $self->SetFileName($target, $hardLink, 'HardLink');
+            ++$$self{CHANGED} if defined $symLink and $self->SetFileName($target, $symLink, 'SymLink');
+            defined $testName and $self->SetFileName($target, $testName, 'Test');
+        }
     }
     # check for write error and set appropriate error message and return value
@@ -1922,8 +2530,8 @@
         $rtnVal = 0;    # return 0 on failure
     } elsif ($rtnVal > 0) {
-        ++$rtnVal unless $self->{CHANGED};
+        ++$rtnVal unless $$self{CHANGED};
     }
     # set things back to the way they were
-    $self->{RAF} = $oldRaf;
+    $$self{RAF} = $oldRaf;
 
     return $rtnVal;
@@ -1942,5 +2550,5 @@
     @groups = split ':', $group if $group;
 
-    my $exifTool = new Image::ExifTool;
+    my $et = new Image::ExifTool;
     LoadAllTables();    # first load all our tables
     my @tableNames = keys %allTables;
@@ -1949,4 +2557,8 @@
     while (@tableNames) {
         my $table = GetTagTable(pop @tableNames);
+        # generate flattened tag names for structure fields if this is an XMP table
+        if ($$table{GROUPS} and $$table{GROUPS}{0} eq 'XMP') {
+            Image::ExifTool::XMP::AddFlattenedTags($table);
+        }
         my $tagID;
         foreach $tagID (TagTableKeys($table)) {
@@ -1960,5 +2572,5 @@
                 next if $$tagInfo{Hidden};  # ignore hidden tags
                 if (@groups) {
-                    my @tg = $exifTool->GetGroup($tagInfo);
+                    my @tg = $et->GetGroup($tagInfo);
                     foreach $group (@groups) {
                         next GATInfo unless grep /^$group$/i, @tg;
@@ -1975,5 +2587,5 @@
 # Get list of all writable tags
 # Inputs: 0) optional group name (or names separated by colons)
-# Returns: tag list (sorted alphbetically)
+# Returns: tag list (sorted alphabetically)
 sub GetWritableTags(;$)
 {
@@ -1983,5 +2595,5 @@
     @groups = split ':', $group if $group;
 
-    my $exifTool = new Image::ExifTool;
+    my $et = new Image::ExifTool;
     LoadAllTables();
     my @tableNames = keys %allTables;
@@ -1990,11 +2602,15 @@
         my $tableName = pop @tableNames;
         my $table = GetTagTable($tableName);
+        # generate flattened tag names for structure fields if this is an XMP table
+        if ($$table{GROUPS} and $$table{GROUPS}{0} eq 'XMP') {
+            Image::ExifTool::XMP::AddFlattenedTags($table);
+        }
         # attempt to load Write tables if autoloaded
-        my @path = split(/::/,$tableName);
-        if (@path > 3) {
-            my $i = $#path - 1;
-            $path[$i] = "Write$path[$i]";   # add 'Write' before class name
-            my $module = join('::',@path[0..($#path-1)]);
-            eval "require $module"; # (fails silently if nothing loaded)
+        my @parts = split(/::/,$tableName);
+        if (@parts > 3) {
+            my $i = $#parts - 1;
+            $parts[$i] = "Write$parts[$i]";   # add 'Write' before class name
+            my $module = join('::',@parts[0..$i]);
+            eval { require $module }; # (fails silently if nothing loaded)
         }
         my $tagID;
@@ -2006,9 +2622,9 @@
                 $tag or warn("no name for tag!\n"), next;
                 my $writable = $$tagInfo{Writable};
-                next unless $writable or ($table->{WRITABLE} and
+                next unless $writable or ($$table{WRITABLE} and
                     not defined $writable and not $$tagInfo{SubDirectory});
                 next if $$tagInfo{Hidden};  # ignore hidden tags
                 if (@groups) {
-                    my @tg = $exifTool->GetGroup($tagInfo);
+                    my @tg = $et->GetGroup($tagInfo);
                     foreach $group (@groups) {
                         next GWTInfo unless grep /^$group$/i, @tg;
@@ -2024,13 +2640,17 @@
 #------------------------------------------------------------------------------
 # Get list of all group names
-# Inputs: 1) Group family number
+# Inputs: 0) [optional] ExifTool ref, 1) Group family number
 # Returns: List of group names (sorted alphabetically)
-sub GetAllGroups($)
+sub GetAllGroups($;$)
 {
     local $_;
     my $family = shift || 0;
+    my $self;
+    ref $family and $self = $family, $family = shift || 0;
 
     $family == 3 and return('Doc#', 'Main');
     $family == 4 and return('Copy#');
+    $family == 5 and return('[too many possibilities to list]');
+    $family == 6 and return(@Image::ExifTool::Exif::formatName[1..$#Image::ExifTool::Exif::formatName]);
 
     LoadAllTables();    # first load all our tables
@@ -2046,10 +2666,25 @@
         foreach $tag (TagTableKeys($table)) {
             my @infoArray = GetTagInfoList($table, $tag);
-            foreach $tagInfo (@infoArray) {
-                next unless ($grps = $$tagInfo{Groups}) and ($grp = $$grps{$family});
-                $allGroups{$grp} = 1;
-            }
-        }
-    }
+            if ($family == 7) {
+                foreach $tagInfo (@infoArray) {
+                    my $id = $$tagInfo{TagID};
+                    if (not defined $id) {
+                        $id = '';   # (just to be safe)
+                    } elsif ($id =~ /^\d+$/) {
+                        $id = sprintf('0x%x', $id) if $self and $$self{OPTIONS}{HexTagIDs};
+                    } else {
+                        $id =~ s/([^-_A-Za-z0-9])/sprintf('%.2x',ord $1)/ge;
+                    }
+                    $allGroups{'ID-' . $id} = 1;
+                }
+            } else {
+                foreach $tagInfo (@infoArray) {
+                    next unless ($grps = $$tagInfo{Groups}) and ($grp = $$grps{$family});
+                    $allGroups{$grp} = 1;
+                }
+            }
+        }
+    }
+    delete $allGroups{'*'};     # (not a real group)
     return sort keys %allGroups;
 }
@@ -2062,5 +2697,5 @@
 {
     my $self = shift;
-    return @{$self->{WRITE_GROUPS}};
+    return @{$$self{WRITE_GROUPS}};
 }
 
@@ -2070,9 +2705,40 @@
 sub GetDeleteGroups()
 {
-    return sort @delGroups;
+    return sort @delGroups, @delGroup2;
+}
+
+#------------------------------------------------------------------------------
+# Add user-defined tags at run time
+# Inputs: 0) destination table name, 1) tagID/tagInfo pairs for tags to add
+# Returns: number of tags added
+# Notes: will replace existing tags
+sub AddUserDefinedTags($%)
+{
+    local $_;
+    my ($tableName, %addTags) = @_;
+    my $table = GetTagTable($tableName) or return 0;
+    # add tags to writer lookup
+    Image::ExifTool::TagLookup::AddTags(\%addTags, $tableName);
+    my $tagID;
+    my $num = 0;
+    foreach $tagID (keys %addTags) {
+        next if $specialTags{$tagID};
+        delete $$table{$tagID}; # delete old entry if it existed
+        AddTagToTable($table, $tagID, $addTags{$tagID}, 1);
+        ++$num;
+    }
+    return $num;
 }
 
 #==============================================================================
 # Functions below this are not part of the public API
+
+#------------------------------------------------------------------------------
+# Maintain backward compatibility for old GetNewValues function name
+sub GetNewValues($$;$)
+{
+    my ($self, $tag, $nvHashPt) = @_;
+    return $self->GetNewValue($tag, $nvHashPt);
+}
 
 #------------------------------------------------------------------------------
@@ -2087,7 +2753,8 @@
     # make sure the Perl UTF-8 flag is OFF for the value if perl 5.6 or greater
     # (otherwise our byte manipulations get corrupted!!)
-    if ($] >= 5.006 and (eval 'require Encode; Encode::is_utf8($$valPt)' or $@)) {
+    if ($] >= 5.006 and (eval { require Encode; Encode::is_utf8($$valPt) } or $@)) {
+        local $SIG{'__WARN__'} = \&SetWarning;
         # repack by hand if Encode isn't available
-        $$valPt = $@ ? pack('C*',unpack('U0C*',$$valPt)) : Encode::encode('utf8',$$valPt);
+        $$valPt = $@ ? pack('C*',unpack($] < 5.010000 ? 'U0C*' : 'C0C*',$$valPt)) : Encode::encode('utf8',$$valPt);
     }
     # un-escape value if necessary
@@ -2097,5 +2764,5 @@
             $$valPt = Image::ExifTool::XMP::UnescapeXML($$valPt);
         } elsif ($$self{OPTIONS}{Escape} eq 'HTML') {
-            $$valPt = Image::ExifTool::HTML::UnescapeHTML($$valPt);
+            $$valPt = Image::ExifTool::HTML::UnescapeHTML($$valPt, $$self{OPTIONS}{Charset});
         }
     }
@@ -2106,11 +2773,15 @@
 # Inputs: 0) ExifTool ref, 1) value, 2) tagInfo (or Struct item) ref,
 #         3) tag name, 4) group 1 name, 5) conversion type (or undef),
-#         6) [optional] want group
+#         6) [optional] want group ("" for structure field)
 # Returns: 0) converted value, 1) error string (or undef on success)
-# Notes: Uses ExifTool "ConvType" member to specify conversion type
+# Notes:
+# - uses ExifTool "ConvType" member when conversion type is undef
+# - conversion types other than 'ValueConv' and 'PrintConv' are treated as 'Raw'
 sub ConvInv($$$$$;$$)
 {
     my ($self, $val, $tagInfo, $tag, $wgrp1, $convType, $wantGroup) = @_;
     my ($err, $type);
+
+    $convType or $convType = $$self{ConvType} || 'PrintConv';
 
 Conv: for (;;) {
@@ -2118,48 +2789,57 @@
             # split value into list if necessary
             if ($$tagInfo{List}) {
-                my $listSplit = $$tagInfo{AutoSplit} || $self->{OPTIONS}{ListSplit};
-                if (defined $listSplit) {
+                my $listSplit = $$tagInfo{AutoSplit} || $$self{OPTIONS}{ListSplit};
+                if (defined $listSplit and not $$tagInfo{Struct} and
+                    ($wantGroup or not defined $wantGroup))
+                {
                     $listSplit = ',?\s+' if $listSplit eq '1' and $$tagInfo{AutoSplit};
-                    my @splitVal = split /$listSplit/, $val;
-                    $val = \@splitVal if @splitVal > 1;
-                }
-            }
-            $type = $convType || $$self{ConvType} || 'PrintConv';
-        } elsif ($type ne 'ValueConv') {
+                    my @splitVal = split /$listSplit/, $val, -1;
+                    $val = @splitVal > 1 ? \@splitVal : @splitVal ? $splitVal[0] : '';
+                }
+            }
+            $type = $convType;
+        } elsif ($type eq 'PrintConv') {
             $type = 'ValueConv';
-        } else {    
+        } else {
+            # split raw value if necessary
+            if ($$tagInfo{RawJoin} and $$tagInfo{List} and not ref $val) {
+                my @splitVal = split ' ', $val;
+                $val = \@splitVal if @splitVal > 1;
+            }
             # finally, do our value check
             my ($err2, $v);
-            if ($tagInfo->{WriteCheck}) {
+            if ($$tagInfo{WriteCheck}) {
                 #### eval WriteCheck ($self, $tagInfo, $val)
-                $err2 = eval $tagInfo->{WriteCheck};
+                $err2 = eval $$tagInfo{WriteCheck};
                 $@ and warn($@), $err2 = 'Error evaluating WriteCheck';
             }
             unless ($err2) {
-                my $table = $tagInfo->{Table};
-                if ($table and $table->{CHECK_PROC} and not $$tagInfo{RawConvInv}) {
-                    my $checkProc = $table->{CHECK_PROC};
+                my $table = $$tagInfo{Table};
+                if ($table and $$table{CHECK_PROC} and not $$tagInfo{RawConvInv}) {
+                    my $checkProc = $$table{CHECK_PROC};
                     if (ref $val eq 'ARRAY') {
                         # loop through array values
                         foreach $v (@$val) {
-                            $err2 = &$checkProc($self, $tagInfo, \$v);
+                            $err2 = &$checkProc($self, $tagInfo, \$v, $convType);
                             last if $err2;
                         }
                     } else {
-                        $err2 = &$checkProc($self, $tagInfo, \$val);
+                        $err2 = &$checkProc($self, $tagInfo, \$val, $convType);
                     }
                 }
             }
             if (defined $err2) {
-                # skip writing this tag if error string is empty
-                $err2 or goto WriteAlso;
-                $err = "$err2 for $wgrp1:$tag";
-                $self->VPrint(2, "$err\n");
-                undef $val; # value was invalid
+                if ($err2) {
+                    $err = "$err2 for $wgrp1:$tag";
+                    $self->VPrint(2, "$err\n");
+                    undef $val;     # value was invalid
+                } else {
+                    $err = $err2;   # empty error (quietly don't write tag)
+                }
             }
             last;
         }
-        my $conv = $tagInfo->{$type};
-        my $convInv = $tagInfo->{"${type}Inv"};
+        my $conv = $$tagInfo{$type};
+        my $convInv = $$tagInfo{"${type}Inv"};
         # nothing to do at this level if no conversion defined
         next unless defined $conv or defined $convInv;
@@ -2212,9 +2892,9 @@
                 }
             } elsif ($conv) {
-                if (ref $conv eq 'HASH') {
+                if (ref $conv eq 'HASH' and (not exists $$tagInfo{"${type}Inv"} or $convInvList)) {
                     my ($multi, $lc);
                     # insert alternate language print conversions if required
                     if ($$self{CUR_LANG} and $type eq 'PrintConv' and
-                        ref($lc = $self->{CUR_LANG}{$tag}) eq 'HASH' and
+                        ref($lc = $$self{CUR_LANG}{$tag}) eq 'HASH' and
                         ($lc = $$lc{PrintConv}))
                     {
